/* 
 * File:   main.cpp
 * Author: arthur
 *
 * Created on 2009年12月8日, 下午11:51
 */


#include <stdio.h>
#include <stdlib.h>
#include <string>
#include "/usr/include/mysql/mysql.h"
#pragma comment (lib, "libmysql.lib")
using namespace std;


int main()
{
    MYSQL            *connection;
    MYSQL_RES        *resource;
    MYSQL_ROW          result;

    string            servername     = "localhost";
    string            user           = "root";
    string            password       = "nadal";
    string            database       = "menagerie";
    string            socket         = "/opt/lampp/var/mysql/mysql.sock";
    string            hostinfo;
    string            serverinfo;
    int               protoinfo;

    /* Intitialize connection to database, and MYSQL structure. */
    connection = mysql_init(NULL);

    /* Connect to database */
//    if(!mysql_real_connect(connection, servername.c_str(), user.c_str(),
//        password.c_str(), database.c_str(), 3306, socket.c_str(), 0)) {
//            printf("%s\n", mysql_error(connection));
//        }
    if(!mysql_real_connect(connection, servername.c_str(), user.c_str(),
        password.c_str(), database.c_str(), 3306, NULL, 0)) {
            printf("%s\n", mysql_error(connection));
        }
    /* Get host info */
    hostinfo = mysql_get_host_info(connection);

    /* Get server info */
    serverinfo = mysql_get_server_info(connection);

    /* Get protocol info */
    protoinfo = mysql_get_proto_info(connection);

    /* Output get info */
    printf("Host: %s\n", hostinfo.c_str());
    printf("Server: %s\n", serverinfo.c_str());
    printf("Protocol: %d", protoinfo);

    /* Execute our SHOW DATABASES statement */
    mysql_query(connection, "SHOW DATABASES");

    /* Resource structure with the rows of data from SHOW DATABASES */
    resource = mysql_use_result(connection);

    printf("Databases:\n\n");

    /* Fetch & print each row */
    while((result = mysql_fetch_row(resource))) {
        printf("%s\n", result[0]);
    }

    /* SELECT more data from world database. */
    mysql_query(connection, "select * from menagerie.pet");

    /* Resource struct with rows of returned data. */
    resource = mysql_use_result(connection);

    printf("\n\nname and owner in pet table:\n\n");

    /* Print out all our cities with populations */
    while((result = mysql_fetch_row(resource))) {
        printf("%s %s\n",result[0], result[1]);
    }

    /* UPDATE San Diego population */
    mysql_query(connection, \
        "UPDATE pet SET name=\"Arthur\" WHERE owner=\"Harold\"");

    printf("%ld Row(s) Updated!\n", (long) mysql_affected_rows(connection));

    /* SELECT newly inserted record. */
    mysql_query(connection, \
        "SELECT Name, owner FROM pet WHERE Name = \"arthur\"");

    /* Resource struct with rows of returned data. */
    resource = mysql_use_result(connection);

    /* Fetch single result */
    result = mysql_fetch_row(resource);

    /* Display San Diego's new population */
    printf("%s %s\n",result[0], result[1]);

    /* Free memory used by resource */
    mysql_free_result(resource);

    /* Closes connection to database, frees memory used by connection. */
    mysql_close(connection);

    /* Frees up other memory used by the libmysqlclient. */
    mysql_library_end();

    return 0;

}

